
var pSlideShow = {
	width: function() {
		return pSlideShow.m_data.x_div_slideshow.offsetWidth - pStyle.borderLeftWidth(pSlideShow.m_data.x_div_slideshow) - pStyle.borderRightWidth(pSlideShow.m_data.x_div_slideshow);
	},
	height: function() {
		return pSlideShow.m_data.x_div_slideshow.offsetHeight - pStyle.borderBottomWidth(pSlideShow.m_data.x_div_slideshow) - pStyle.borderTopWidth(pSlideShow.m_data.x_div_slideshow);
	},
	getImageTop: function() {
		var i_rect = pSlideShow.m_data.x_div_slideshow.getBoundingClientRect();
		return i_rect.top + pStyle.borderTopWidth(pSlideShow.m_data.x_div_slideshow) + pSlideShow.m_data.m_element_toolbar.offsetHeight;
	},
	getImageWidth: function() {
		//return window.innerHeight - pSlideShow.m_data.m_element_toolbar.offsetHeight - pSlideShow.m_data.m_element_tags.offsetHeight - pStyle.borderBottomWidth(pSlideShow.m_data.m_element_image) - pStyle.borderTopWidth(pSlideShow.m_data.m_element_image);
		return pSlideShow.width() - pStyle.borderLeftWidth(pSlideShow.m_data.m_element_image) - pStyle.borderRightWidth(pSlideShow.m_data.m_element_image);
	},
	getImageHeight: function() {
		//return window.innerHeight - pSlideShow.m_data.m_element_toolbar.offsetHeight - pSlideShow.m_data.m_element_tags.offsetHeight - pStyle.borderBottomWidth(pSlideShow.m_data.m_element_image) - pStyle.borderTopWidth(pSlideShow.m_data.m_element_image);
		return pSlideShow.height() - pSlideShow.m_data.m_element_toolbar.offsetHeight - pSlideShow.m_data.m_element_tags.offsetHeight - pStyle.borderBottomWidth(pSlideShow.m_data.m_element_image) - pStyle.borderTopWidth(pSlideShow.m_data.m_element_image);
	},
	openImage: function() {
		pSlideShow.setCookie('n', pSlideShow.m_data.number);

		var i_current = pSlideShow.m_data.m_imgs[pSlideShow.m_data.number];
		pLocation.setLocation(pSlideShow.createURL(i_current.name));
	},
	resizeThumbs: function() {
		var i_h = pSlideShow.getImageHeight();
		pSlideShow.m_data.m_element_image.style.height = i_h;
		document.getElementById('div-img'+pSlideShow.m_data.ximgi).style.height = i_h;
		//pSlideShow.m_data.m_element_thumbs.style.height = i_h;

		var i_w = pSlideShow.getImageWidth();
		pSlideShow.m_data.m_element_image.style.width = i_w;
		pSlideShow.m_data.m_element_toolbar.style.width = i_w -20;
		document.getElementById('div-img'+pSlideShow.m_data.ximgi).style.width = i_w;

		//i_w = pSlideShow.m_data.x_div_slideshow.clientWidth/*pSlideShow.width()*/ - pStyle.borderLeftWidth(pSlideShow.m_data.m_element_thumbs) - pStyle.borderRightWidth(pSlideShow.m_data.m_element_thumbs) -32;
		pSlideShow.m_data.m_element_thumbs.style.width = ''+i_w+'px';

		var twidth = 0;//pSlideShow.m_data.m_element_image.clientWidth;
		if (twidth<1)
			twidth = pSlideShow.m_data.m_element_thumbs.clientWidth;
		//twidth -= 2;

		var cwidth = 0;//8;
		var linef = 1;

		for(var i=1 ; i<pSlideShow.m_data.m_imgs.length ; i++) {

			var i_thumb = document.getElementById('thumb-img-'+i);
			var i_scaled = pSlideShow.scaleImageObject(pSlideShow.m_data.m_imgs[i]);

			if (i_scaled.width>-1 && i_scaled.height>-1) {
				cwidth += i_scaled.width + 8;

				//i_thumb.title = 'avail: ' + twidth + ', img: ' + i_scaled.width + ', total: ' + cwidth;

				if (cwidth > twidth && twidth>0) {

					var iwidth = [ 0 ];
					var rest = cwidth - twidth;
					var orest = rest;
					var n = i-linef + 1;
					var rem = Math.floor(rest / n);
					for(var j = linef ; j<=i ; j++) {

						var i_jthumb = document.getElementById('thumb-img-'+j);
						var i_jscaled = pSlideShow.scaleImageObject(pSlideShow.m_data.m_imgs[j]);

						var nwidth = i_jscaled.width - rem;

						iwidth[iwidth.length] = nwidth;
						rest -= rem;
						i_jthumb.style.width = ''+nwidth+'px';

						//i_jthumb.title = i_jthumb.title + ', tosave: ' + orest + ' between ' + n + ' imgs, remove: ' + rem + ' -> ' + i_jthumb.style.width;
					}

					while(rest>0) {
						for(var j = linef ; j<=i && rest>0; j++) {

							var i_jthumb = document.getElementById('thumb-img-'+j);

							var nwidth = iwidth[j-linef+1] -1;

							iwidth[j-linef+1] = nwidth;
							rest -= 1;
							i_jthumb.style.width = ''+nwidth+'px';

							//i_jthumb.title = i_jthumb.title + ' -> ' + i_jthumb.style.width;
						}
					}

					linef = i+1;
					cwidth = 0;//8;
				}
			}
		}
	},
	start: function(p_imgs, p_port) {

		var i_param = pLocation.getQueryParam('title');
		if (null!=i_param)
			pSlideShow.setTitle(i_param);

		pSlideShow.m_data.x_div_slideshow = document.getElementById('slideshow');
		pSlideShow.m_data.m_element_image = document.getElementById('image');
		pSlideShow.m_data.m_element_toolbar = document.getElementById('toolbar');
		pSlideShow.m_data.m_element_tags = document.getElementById('tags');
		pSlideShow.m_data.m_element_thumbs = document.getElementById('thumbs');
		pSlideShow.m_data.ximg = document.getElementById('img');

		pSlideShow.resizeThumbs();

		pSlideShow.m_data.m_imgs = [];
		for(var i=0 ; i<p_imgs.length ; i++)
			if (p_imgs[i])
				pSlideShow.m_data.m_imgs[pSlideShow.m_data.m_imgs.length] = p_imgs[i];
				
		pSlideShow.m_data.m_imgs.sort(function(x, y) {
			if (x === "")
				return -1;
			if (x.date == y.date)
				return 0;
			if (x.date < y.date)
				return -1;
			return 1;
		});
		pSlideShow.m_data.m_image_server_port = p_port;

		var number_cookie = pSlideShow.getCookie("n");
		if (number_cookie=="")
		    pSlideShow.m_data.number = 1;
		else
		    pSlideShow.m_data.number = parseInt(number_cookie);
		pSlideShow.m_data.number_prev = pSlideShow.m_data.number;

		pSlideShow.refresh();
		/*addEvent(window, 'resize', function() {
			pSlideShow.resizeThumbs();
		});*/

		//*** CREATE THUMBNAILS
		var i_html = '';
		for(var i=1 ; i<pSlideShow.m_data.m_imgs.length ; i++) {
			if (i==pSlideShow.m_data.number)
				i_html += '<div id=\"thumb-'+i+'\" class=\"thumb-selected\">';
			else
				i_html += '<div id=\"thumb-'+i+'\" class=\"thumb\">';

			var i_current = pSlideShow.m_data.m_imgs[i];
			var i_url = pSlideShow.createImageURL(i_current);
			var i_thumb_url = pSlideShow.createThumbURL(pSlideShow.m_data.m_imgs[i]);

			i_html += '<a id="thumb-link-'+i+'" href="javascript:pSlideShow.goto('+i+');" class="thumb-link">';
			i_html += '<img id="thumb-img-'+i+'" src="'+i_thumb_url+'" class="thumb-img" title="'+pSlideShow.private.tooltip(i_current, i_url)+'">';
			i_html += '</a></div>';
		}
		pSlideShow.m_data.m_element_thumbs.innerHTML = i_html;

		pSlideShow.refreshSelectedThumb();

		//*** RESIZE THUMBNAILS
		setTimeout(function() { pSlideShow.resizeThumbs(); }, 1);

		//*** DETECT MOUSE WHEEL
		window.addWheelListener(pSlideShow.m_data.x_div_slideshow, function( e ) {
			if (pSlideShow.m_data.thumbs_mode === true)
				return;

			if (e.deltaY > 0)
				pSlideShow.next();
			else
				pSlideShow.previous();
			//console.log( e.deltaY );
			e.preventDefault();
		});
		/*document.addEventListener("wheel", function(i_event) {
			alert(i_event+' '+i_event.wheelDelta+' '+i_wheel.detail);
			if (i_event.wheelDelta >= 120)
				pSlideShow.previous();
			else
				pSlideShow.next();
		}, false);*/
	},
	goto: function(x) {
		if (x>0 && x<=pSlideShow.m_data.m_imgs.length-1) {
			if (pSlideShow.m_data.number == x) {
				pSlideShow.showImage();
				return;
			}
		
			pTags.save(true);
			pSlideShow.m_data.number_prev = pSlideShow.m_data.number;
			pSlideShow.m_data.number = x;
			pSlideShow.refresh();
		}
	},
	close: function() {
		//pTags.save();
		history.back();
	},
	first: function() {
		pSlideShow.goto(1);
	},
	next: function() {
		pSlideShow.goto(pSlideShow.m_data.number+1);
	},
	previous: function() {
		pSlideShow.goto(pSlideShow.m_data.number-1);
	},
	last: function() {
		pSlideShow.goto(pSlideShow.m_data.m_imgs.length-1);
	},
	m_disableButton: function(link) {
		link.className = "button-disabled";
		link.removeAttribute("href");
		/*		link.style.textDecoration="none";
				link.style.cursor="default";
				link.href="";
				link.style.color="black";*/
	},
	m_enableButton: function(link, url) {
		link.className = "button";
		/*		link.style.textDecoration="underline";
				link.style.cursor="pointer";
				link.style.color="blue";*/
		link.href = url;
	},
	scaleImageObject: function(p_img) {
		var sw = screen.width;
		var sh = screen.height;

		if (p_img.owidth>0 && p_img.oheight>0) {
			if (p_img.owidth<=sw && p_img.oheight<=sh)
				return p_img;
		}

		if (p_img.s1024x768!=null)
			if (sw<=1024 || sh<=768)
				return p_img.s1024x768;

		if (p_img.s1920x1080!=null)
			if (sw<=1920 || sh<=1080)
				return p_img.s1920x1080;

		return p_img;
	},
	createThumbURL: function(p_img) {
		return pSlideShow.createURL(pSlideShow.scaleImageObject(p_img).thumb);
	},
	createImageURL: function(p_img) {
		var i_scaled = pSlideShow.scaleImageObject(p_img);
		if (i_scaled != p_img) {
			//if (pLocation.isLocalhost() && i_scaled.file)
			//	return "file:///" + encodeURI(i_scaled.file);
			return pSlideShow.createURL(i_scaled.name);//(pLocation.isLocalhost())? "file:///"+i_scaled.file : i_scaled.name);
		}
		
		//if (pLocation.isLocalhost() && i_scaled.file)
		//		return "file:///" + encodeURI(i_scaled.file);
		
		w = window.innerWidth;
		h = window.innerHeight;
		//alert("w: " + window.innerWidth + "\nh: " + window.innerHeight);
		if (pSlideShow.m_data.m_image_server_port>0) {
			if (p_img.owidth>0 && p_img.owidth > w)
				return "http://"+pLocation.getHostname()+":"+pSlideShow.m_data.m_image_server_port+"/image/scale?file="+encodeURIComponent(p_img.file)+"&w="+w+"&h="+h;
			if (p_img.oheight>0 && p_img.oheight > h)
				return "http://"+pLocation.getHostname()+":"+pSlideShow.m_data.m_image_server_port+"/image/scale?file="+encodeURIComponent(p_img.file)+"&w="+w+"&h="+h;
		}
		return pSlideShow.createURL(p_img.name);//(pLocation.isLocalhost())? "file:///"+p_img.file : p_img.name);
	},
	createURL: function(name) {
		return encodeURIComponent(name);//.replace(/#/g, '%23');//.replace(/ /g, "%20");
	},
	showThumbs: function() {
		if (pSlideShow.m_data.thumbs_mode === true)
			return;

		pSlideShow.m_data.thumbs_mode = true;

		window.scrollTo(pSlideShow.m_data.thumbs_scroll.x, pSlideShow.m_data.thumbs_scroll.y);
		pDocument.hide(pSlideShow.m_data.m_element_image);
		pDocument.hide(pSlideShow.m_data.m_element_tags);
		pDocument.show(pSlideShow.m_data.m_element_thumbs);

		//pSlideShow.m_data.m_element_image.style.display="none";
		//pSlideShow.m_data.m_element_tags.style.display="none";
		//pSlideShow.m_data.m_element_thumbs.style.display="block";
		document.getElementById('thumb-link-'+pSlideShow.m_data.number).focus();
	},
	showImage: function() {
		if (pSlideShow.m_data.thumbs_mode === false)
			return;

		pSlideShow.m_data.thumbs_scroll = { x: window.pageXOffset, y: window.pageYOffset };
		pSlideShow.m_data.thumbs_mode = false;

		window.scrollTo(0, 0);
		pDocument.show(pSlideShow.m_data.m_element_image);
		pDocument.hide(pSlideShow.m_data.m_element_tags);
		pDocument.hide(pSlideShow.m_data.m_element_thumbs);

		//pSlideShow.m_data.m_element_image.style.display="block";
		//pSlideShow.m_data.m_element_tags.style.display="block";
		//pSlideShow.m_data.m_element_thumbs.style.display="none";
	},
	setCookie: function(cname, cvalue) {
		document.cookie = cname + "=" + cvalue;// + "; " + expires;
	},
	getCookie: function(cname) {
		var name = cname + "=";
		var ca = document.cookie.split(';');
		for(var i=0; i<ca.length; i++) {
			var c = ca[i].trim();
			if (c.indexOf(name)==0) return c.substring(name.length,c.length);
		}
		return "";
	},
	refreshSelectedThumb: function() {

		for(var i=1 ; i<pSlideShow.m_data.m_imgs.length ; i++) {
			if (null==document.getElementById('thumb-'+i))
				break;

			if (i==pSlideShow.m_data.number) {
				document.getElementById('thumb-'+i).className = "thumb-selected";
				//document.getElementById('thumb-'+i).style.border="solid blue 2px";
				//document.getElementById('thumb-'+i).style.padding="2px";
			}
			else {
				document.getElementById('thumb-'+i).className = "thumb";
				//document.getElementById('thumb-'+i).style.border="solid transparent 4px";
				//document.getElementById('thumb-'+i).style.padding="0px";
			}
		}
		return;
	},
	m_data: {
		m_imgs: [],
		m_image_server_port: null,
		x_div_slideshow: document.getElementById('slideshow'),
		number: 1,
	    number_prev: 1,
		thumbs_mode: true,
		m_element_image: document.getElementById('image'),
		m_element_toolbar: document.getElementById('toolbar'),
		m_element_tags: document.getElementById('tags'),
		m_element_thumbs: document.getElementById('thumbs'),
		ximg: document.getElementById('img'),
		ximgi: 0,
		thumbs_scroll: { x: 0, y: 0 }
	},
	refresh: function() {
		document.cookie = "n=; expires=Thu, 01 Jan 1970 00:00:00 GMT";

		pSlideShow.showImage();

		var i_current = pSlideShow.m_data.m_imgs[pSlideShow.m_data.number];
		var img = pSlideShow.createImageURL(i_current);
		//console.log('img : ' + img);
		var ximg_prev;

		if (pSlideShow.m_data.number_prev!=pSlideShow.m_data.number) {
			var x = document.getElementById("image");

			ximg_prev = pSlideShow.m_data.ximg;

			if (pSlideShow.m_data.number_prev < pSlideShow.m_data.number)
				setTimeout(function() { ximg_prev.className = "div-img slide out"; }, 1);
			else
				setTimeout(function() { ximg_prev.className = "div-img slide reverse out"; }, 1);

			pSlideShow.m_data.ximg = document.createElement("div");
			pSlideShow.m_data.ximgi++;
			pSlideShow.m_data.ximg.id = "div-img"+pSlideShow.m_data.ximgi;
			//pSlideShow.m_data.ximgi++;

			//<img title="4bpwOyFIvVriY1duLjjjEblG0zU.jpg" alt="4bpwOyFIvVriY1duLjjjEblG0zU.jpg" class="img-transform-0" id="img" rel="noreferrer"
			//style="background: url('/line-wait.gif') no-repeat;" src="test_files/4bpwOyFIvVriY1duLjjjEblG0zU.jpg">
			pSlideShow.m_data.ximg.className = "div-img";
			//pSlideShow.m_data.ximg.style.left = "100%";
			
			pSlideShow.m_data.ximg.style.textAlign = "center";
			pSlideShow.m_data.ximg.style.width = pSlideShow.getImageWidth();
			pSlideShow.m_data.ximg.style.height = pSlideShow.getImageHeight();
			//pSlideShow.m_data.ximg.style.backgroundColor = "orange";
			pSlideShow.m_data.ximg.style.position = "absolute";
			pSlideShow.m_data.ximg.style.top = "50px";

			//xsimg
			pSlideShow.m_data.ximg.innerHTML = 
				'<img id="img'+pSlideShow.m_data.ximgi+'" class="button img-transform-0" onclick="pSlideShow.openImage();" src="'+img+'" alt="'+img+'" title="'+pSlideShow.private.tooltip(i_current, img)+'"/>';
			//x.appendChild(pSlideShow.m_data.ximg);
		}
		else {
			pSlideShow.m_data.ximg = document.getElementById('div-img0');
			
			var x_img = document.getElementById('img'+pSlideShow.m_data.ximgi);

			x_img.src = img;
			x_img.alt = img;
			x_img.title = pSlideShow.private.tooltip(i_current, img);
		}

		pSlideShow.m_data.ximg.style.top = pSlideShow.getImageTop();

		//var x_img = document.getElementById('img'+pSlideShow.m_data.ximgi);

		//*** PAGE TITLE
		top.document.title = pSlideShow.private.title(i_current);

		//x_img.src = img;
		//x_img.alt = img;
		//x_img.title = pSlideShow.private.tooltip(i_current, img);

		//var i_orientation = pSlideShow.m_data.m_imgs[pSlideShow.m_data.number].orientation;
		//if (null!=i_orientation)
		//	x_img.className = 'img-transform-'+parseInt(i_orientation);

		if (pSlideShow.m_data.number_prev!=pSlideShow.m_data.number) {
			//x.appendChild(pSlideShow.m_data.ximg);
			//setTimeout(function(){ x.removeChild(ximg_prev); }, 1);
			if (pSlideShow.m_data.number_prev < pSlideShow.m_data.number)
				setTimeout(function(){ pSlideShow.m_data.ximg.className = "div-img slide in"; document.getElementById("image").appendChild(pSlideShow.m_data.ximg); },1);
			else
				setTimeout(function(){ pSlideShow.m_data.ximg.className = "div-img slide reverse in"; document.getElementById("image").appendChild(pSlideShow.m_data.ximg); },1);
			setTimeout(function(){ x.removeChild(ximg_prev); }, 706);
		}

		pDocument.setClassName('button-next', (pSlideShow.m_data.number== pSlideShow.m_data.m_imgs.length-1)? 'button-disabled' : 'button');
		pDocument.setClassName('button-last', (pSlideShow.m_data.number== pSlideShow.m_data.m_imgs.length-1)? 'button-disabled' : 'button');
		pDocument.setClassName('button-previous', (pSlideShow.m_data.number== 1)? 'button-disabled' : 'button');
		pDocument.setClassName('button-first', (pSlideShow.m_data.number== 1)? 'button-disabled' : 'button');

		for(i=0;i<document.anchors.length;i++) {
			if (document.anchors[i].name=="next") {
				if (pSlideShow.m_data.number== pSlideShow.m_data.m_imgs.length-1)
					pSlideShow.m_disableButton(document.anchors[i]);
				else
					pSlideShow.m_enableButton(document.anchors[i], "javascript:pSlideShow.next();");
			}
			else if (document.anchors[i].name=="last") {
				if (pSlideShow.m_data.number== pSlideShow.m_data.m_imgs.length-1)
					pSlideShow.m_disableButton(document.anchors[i]);
				else
					pSlideShow.m_enableButton(document.anchors[i], "javascript:pSlideShow.last();");
			}
			else if (document.anchors[i].name=="previous") {
				if (pSlideShow.m_data.number==1)
					pSlideShow.m_disableButton(document.anchors[i]);
				else
					pSlideShow.m_enableButton(document.anchors[i], "javascript:pSlideShow.previous();");
			}
			else if (document.anchors[i].name=="first") {
				if (pSlideShow.m_data.number==1)
					pSlideShow.m_disableButton(document.anchors[i]);
				else
					pSlideShow.m_enableButton(document.anchors[i], "javascript:pSlideShow.first();");
			}
		}

		if (pSlideShow.m_data.number<pSlideShow.m_data.m_imgs.length-1) {
			var i_url = pSlideShow.createImageURL(pSlideShow.m_data.m_imgs[pSlideShow.m_data.number+1]);
			document.getElementById('next-img').src = i_url;
			//console.log('next-img: ' + i_url);
		}
		if (pSlideShow.m_data.number<pSlideShow.m_data.m_imgs.length-2) {
			var i_url = pSlideShow.createImageURL(pSlideShow.m_data.m_imgs[pSlideShow.m_data.number+2]);
			document.getElementById('next-img2').src = i_url;
			//console.log('next-img2: ' + i_url);
		}
		if (pSlideShow.m_data.number>1) {
			var i_url = pSlideShow.createImageURL(pSlideShow.m_data.m_imgs[pSlideShow.m_data.number-1]);
			document.getElementById('previous-img').src = i_url;
			//console.log('next-previous: ' + i_url);
		}
		if (pSlideShow.m_data.number>2) {
			var i_url = pSlideShow.createImageURL(pSlideShow.m_data.m_imgs[pSlideShow.m_data.number-2]);
			document.getElementById('previous-img2').src = i_url;
			//console.log('next-previous2: ' + i_url);
		}

		pSlideShow.refreshSelectedThumb();

		pTags.refresh();
	},
	private: {
		title: function(p_current) {
			var i_title = pSlideShow.getTitle();
			i_title = pSlideShow.m_data.number + '/' + (pSlideShow.m_data.m_imgs.length-1) + ((null!=i_title)? ' '+i_title:'') + ': ' + p_current.name;
			if (p_current.owidth && p_current.oheight)
				i_title += ' (' + p_current.owidth + ' x ' + p_current.oheight + ' pixels)';
			return i_title;
		},
		tooltip: function(p_current, p_img_url) {
			var i_tooltip = pSlideShow.private.title(p_current);
			if (p_img_url != p_current.name)
				i_tooltip += '\n' + p_img_url;
			if (p_current.date != "")
				i_tooltip += '\nDate Taken: ' + p_current.date;
			return i_tooltip;
		},
		m_options: {
			m_title: null
		}
	},
	getTitle: function() {
		return pSlideShow.private.m_options.m_title;
	},
	setTitle: function(p_title) {
		pSlideShow.private.m_options.m_title = p_title;
	}
};

/******************************************************************************/
/***  END OF FILE  ************************************************************/
/******************************************************************************/
